#pragma once
#include "pluginconstants.h"

class CRateConvertor
{
public:
	CRateConvertor(void);
	virtual ~CRateConvertor(void);

	float *m_pIRBuffer;
	float* m_pLeftInputBuffer;
	float* m_pRightInputBuffer;

	// read index for delay lines (input x buffers)
	int m_nReadIndexDL;

	// read index for impulse response buffers
	int m_nReadIndexH;

	// write index for input x buffer
	int m_nWriteIndex;

	int m_nL; // OS value, 2 = 2X Oversampling
	int m_nCurrentL;
	int m_nIRLength;
	int m_nOSCounter;

	void init(int L, int FIRLen, float *pIRBuffer);
	void reset();
	
	// overrides
	virtual void interpolateNextOutputSample(float xnL, float xnR, float& fLeftOutput, float& fRightOutput);
	virtual bool decimateNextOutputSample(float xnL, float xnR, float& fLeftOutput, float& fRightOutput);

	virtual void interpolateSamples(float xnL, float xnR, float* pLeftInterpBuffer, float* pRightInterpBuffer);
	virtual void decimateSamples(float* pLeftDeciBuffer, float* pRightDeciBuffer, float& ynL, float& ynR);

};

